// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: MultiplyData.proto

package ru.omnicomm.pegasus.messaging.settings.general;

public final class MultiplyDataSettingsParser {
  private MultiplyDataSettingsParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface MultiplyDataServerSettingsOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2 [default = 511];
    boolean hasMessageType();
    long getMessageType();
    
    // optional int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int32 messageBlock = 6;
    boolean hasMessageBlock();
    int getMessageBlock();
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings.MultiplyDataServerSettingsItem settingsItem = 100;
    java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> 
        getSettingsItemList();
    ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem getSettingsItem(int index);
    int getSettingsItemCount();
    java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder> 
        getSettingsItemOrBuilderList();
    ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder getSettingsItemOrBuilder(
        int index);
  }
  public static final class MultiplyDataServerSettings extends
      com.google.protobuf.GeneratedMessage
      implements MultiplyDataServerSettingsOrBuilder {
    // Use MultiplyDataServerSettings.newBuilder() to construct.
    private MultiplyDataServerSettings(Builder builder) {
      super(builder);
    }
    private MultiplyDataServerSettings(boolean noInit) {}
    
    private static final MultiplyDataServerSettings defaultInstance;
    public static MultiplyDataServerSettings getDefaultInstance() {
      return defaultInstance;
    }
    
    public MultiplyDataServerSettings getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_fieldAccessorTable;
    }
    
    public interface MultiplyDataServerSettingsItemOrBuilder
        extends com.google.protobuf.MessageOrBuilder {
      
      // optional int64 sourceId = 1;
      boolean hasSourceId();
      long getSourceId();
      
      // optional double multiplier = 2 [default = 1];
      boolean hasMultiplier();
      double getMultiplier();
      
      // optional int32 inputMessageType = 3;
      boolean hasInputMessageType();
      int getInputMessageType();
      
      // optional int32 inputMessageValueType = 4;
      boolean hasInputMessageValueType();
      int getInputMessageValueType();
      
      // optional int32 outputMessageType = 5;
      boolean hasOutputMessageType();
      int getOutputMessageType();
      
      // optional int32 outputMessageValueType = 6;
      boolean hasOutputMessageValueType();
      int getOutputMessageValueType();
    }
    public static final class MultiplyDataServerSettingsItem extends
        com.google.protobuf.GeneratedMessage
        implements MultiplyDataServerSettingsItemOrBuilder {
      // Use MultiplyDataServerSettingsItem.newBuilder() to construct.
      private MultiplyDataServerSettingsItem(Builder builder) {
        super(builder);
      }
      private MultiplyDataServerSettingsItem(boolean noInit) {}
      
      private static final MultiplyDataServerSettingsItem defaultInstance;
      public static MultiplyDataServerSettingsItem getDefaultInstance() {
        return defaultInstance;
      }
      
      public MultiplyDataServerSettingsItem getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_fieldAccessorTable;
      }
      
      private int bitField0_;
      // optional int64 sourceId = 1;
      public static final int SOURCEID_FIELD_NUMBER = 1;
      private long sourceId_;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      
      // optional double multiplier = 2 [default = 1];
      public static final int MULTIPLIER_FIELD_NUMBER = 2;
      private double multiplier_;
      public boolean hasMultiplier() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public double getMultiplier() {
        return multiplier_;
      }
      
      // optional int32 inputMessageType = 3;
      public static final int INPUTMESSAGETYPE_FIELD_NUMBER = 3;
      private int inputMessageType_;
      public boolean hasInputMessageType() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getInputMessageType() {
        return inputMessageType_;
      }
      
      // optional int32 inputMessageValueType = 4;
      public static final int INPUTMESSAGEVALUETYPE_FIELD_NUMBER = 4;
      private int inputMessageValueType_;
      public boolean hasInputMessageValueType() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public int getInputMessageValueType() {
        return inputMessageValueType_;
      }
      
      // optional int32 outputMessageType = 5;
      public static final int OUTPUTMESSAGETYPE_FIELD_NUMBER = 5;
      private int outputMessageType_;
      public boolean hasOutputMessageType() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getOutputMessageType() {
        return outputMessageType_;
      }
      
      // optional int32 outputMessageValueType = 6;
      public static final int OUTPUTMESSAGEVALUETYPE_FIELD_NUMBER = 6;
      private int outputMessageValueType_;
      public boolean hasOutputMessageValueType() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      public int getOutputMessageValueType() {
        return outputMessageValueType_;
      }
      
      private void initFields() {
        sourceId_ = 0L;
        multiplier_ = 1D;
        inputMessageType_ = 0;
        inputMessageValueType_ = 0;
        outputMessageType_ = 0;
        outputMessageValueType_ = 0;
      }
      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized != -1) return isInitialized == 1;
        
        memoizedIsInitialized = 1;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          output.writeInt64(1, sourceId_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          output.writeDouble(2, multiplier_);
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          output.writeInt32(3, inputMessageType_);
        }
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          output.writeInt32(4, inputMessageValueType_);
        }
        if (((bitField0_ & 0x00000010) == 0x00000010)) {
          output.writeInt32(5, outputMessageType_);
        }
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          output.writeInt32(6, outputMessageValueType_);
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt64Size(1, sourceId_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.CodedOutputStream
            .computeDoubleSize(2, multiplier_);
        }
        if (((bitField0_ & 0x00000004) == 0x00000004)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(3, inputMessageType_);
        }
        if (((bitField0_ & 0x00000008) == 0x00000008)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(4, inputMessageValueType_);
        }
        if (((bitField0_ & 0x00000010) == 0x00000010)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(5, outputMessageType_);
        }
        if (((bitField0_ & 0x00000020) == 0x00000020)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(6, outputMessageValueType_);
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      private static final long serialVersionUID = 0L;
      @java.lang.Override
      protected java.lang.Object writeReplace()
          throws java.io.ObjectStreamException {
        return super.writeReplace();
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder>
         implements ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_descriptor;
        }
        
        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_fieldAccessorTable;
        }
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }
        
        private Builder(BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          }
        }
        private static Builder create() {
          return new Builder();
        }
        
        public Builder clear() {
          super.clear();
          sourceId_ = 0L;
          bitField0_ = (bitField0_ & ~0x00000001);
          multiplier_ = 1D;
          bitField0_ = (bitField0_ & ~0x00000002);
          inputMessageType_ = 0;
          bitField0_ = (bitField0_ & ~0x00000004);
          inputMessageValueType_ = 0;
          bitField0_ = (bitField0_ & ~0x00000008);
          outputMessageType_ = 0;
          bitField0_ = (bitField0_ & ~0x00000010);
          outputMessageValueType_ = 0;
          bitField0_ = (bitField0_ & ~0x00000020);
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(buildPartial());
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.getDefaultInstance();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem build() {
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }
        
        private ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return result;
        }
        
        public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem buildPartial() {
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem result = new ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          result.sourceId_ = sourceId_;
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          result.multiplier_ = multiplier_;
          if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
            to_bitField0_ |= 0x00000004;
          }
          result.inputMessageType_ = inputMessageType_;
          if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
            to_bitField0_ |= 0x00000008;
          }
          result.inputMessageValueType_ = inputMessageValueType_;
          if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
            to_bitField0_ |= 0x00000010;
          }
          result.outputMessageType_ = outputMessageType_;
          if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
            to_bitField0_ |= 0x00000020;
          }
          result.outputMessageValueType_ = outputMessageValueType_;
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.getDefaultInstance()) return this;
          if (other.hasSourceId()) {
            setSourceId(other.getSourceId());
          }
          if (other.hasMultiplier()) {
            setMultiplier(other.getMultiplier());
          }
          if (other.hasInputMessageType()) {
            setInputMessageType(other.getInputMessageType());
          }
          if (other.hasInputMessageValueType()) {
            setInputMessageValueType(other.getInputMessageValueType());
          }
          if (other.hasOutputMessageType()) {
            setOutputMessageType(other.getOutputMessageType());
          }
          if (other.hasOutputMessageValueType()) {
            setOutputMessageValueType(other.getOutputMessageValueType());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public final boolean isInitialized() {
          return true;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  onChanged();
                  return this;
                }
                break;
              }
              case 8: {
                bitField0_ |= 0x00000001;
                sourceId_ = input.readInt64();
                break;
              }
              case 17: {
                bitField0_ |= 0x00000002;
                multiplier_ = input.readDouble();
                break;
              }
              case 24: {
                bitField0_ |= 0x00000004;
                inputMessageType_ = input.readInt32();
                break;
              }
              case 32: {
                bitField0_ |= 0x00000008;
                inputMessageValueType_ = input.readInt32();
                break;
              }
              case 40: {
                bitField0_ |= 0x00000010;
                outputMessageType_ = input.readInt32();
                break;
              }
              case 48: {
                bitField0_ |= 0x00000020;
                outputMessageValueType_ = input.readInt32();
                break;
              }
            }
          }
        }
        
        private int bitField0_;
        
        // optional int64 sourceId = 1;
        private long sourceId_ ;
        public boolean hasSourceId() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        public long getSourceId() {
          return sourceId_;
        }
        public Builder setSourceId(long value) {
          bitField0_ |= 0x00000001;
          sourceId_ = value;
          onChanged();
          return this;
        }
        public Builder clearSourceId() {
          bitField0_ = (bitField0_ & ~0x00000001);
          sourceId_ = 0L;
          onChanged();
          return this;
        }
        
        // optional double multiplier = 2 [default = 1];
        private double multiplier_ = 1D;
        public boolean hasMultiplier() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        public double getMultiplier() {
          return multiplier_;
        }
        public Builder setMultiplier(double value) {
          bitField0_ |= 0x00000002;
          multiplier_ = value;
          onChanged();
          return this;
        }
        public Builder clearMultiplier() {
          bitField0_ = (bitField0_ & ~0x00000002);
          multiplier_ = 1D;
          onChanged();
          return this;
        }
        
        // optional int32 inputMessageType = 3;
        private int inputMessageType_ ;
        public boolean hasInputMessageType() {
          return ((bitField0_ & 0x00000004) == 0x00000004);
        }
        public int getInputMessageType() {
          return inputMessageType_;
        }
        public Builder setInputMessageType(int value) {
          bitField0_ |= 0x00000004;
          inputMessageType_ = value;
          onChanged();
          return this;
        }
        public Builder clearInputMessageType() {
          bitField0_ = (bitField0_ & ~0x00000004);
          inputMessageType_ = 0;
          onChanged();
          return this;
        }
        
        // optional int32 inputMessageValueType = 4;
        private int inputMessageValueType_ ;
        public boolean hasInputMessageValueType() {
          return ((bitField0_ & 0x00000008) == 0x00000008);
        }
        public int getInputMessageValueType() {
          return inputMessageValueType_;
        }
        public Builder setInputMessageValueType(int value) {
          bitField0_ |= 0x00000008;
          inputMessageValueType_ = value;
          onChanged();
          return this;
        }
        public Builder clearInputMessageValueType() {
          bitField0_ = (bitField0_ & ~0x00000008);
          inputMessageValueType_ = 0;
          onChanged();
          return this;
        }
        
        // optional int32 outputMessageType = 5;
        private int outputMessageType_ ;
        public boolean hasOutputMessageType() {
          return ((bitField0_ & 0x00000010) == 0x00000010);
        }
        public int getOutputMessageType() {
          return outputMessageType_;
        }
        public Builder setOutputMessageType(int value) {
          bitField0_ |= 0x00000010;
          outputMessageType_ = value;
          onChanged();
          return this;
        }
        public Builder clearOutputMessageType() {
          bitField0_ = (bitField0_ & ~0x00000010);
          outputMessageType_ = 0;
          onChanged();
          return this;
        }
        
        // optional int32 outputMessageValueType = 6;
        private int outputMessageValueType_ ;
        public boolean hasOutputMessageValueType() {
          return ((bitField0_ & 0x00000020) == 0x00000020);
        }
        public int getOutputMessageValueType() {
          return outputMessageValueType_;
        }
        public Builder setOutputMessageValueType(int value) {
          bitField0_ |= 0x00000020;
          outputMessageValueType_ = value;
          onChanged();
          return this;
        }
        public Builder clearOutputMessageValueType() {
          bitField0_ = (bitField0_ & ~0x00000020);
          outputMessageValueType_ = 0;
          onChanged();
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings.MultiplyDataServerSettingsItem)
      }
      
      static {
        defaultInstance = new MultiplyDataServerSettingsItem(true);
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings.MultiplyDataServerSettingsItem)
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2 [default = 511];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int32 messageBlock = 6;
    public static final int MESSAGEBLOCK_FIELD_NUMBER = 6;
    private int messageBlock_;
    public boolean hasMessageBlock() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public int getMessageBlock() {
      return messageBlock_;
    }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings.MultiplyDataServerSettingsItem settingsItem = 100;
    public static final int SETTINGSITEM_FIELD_NUMBER = 100;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> settingsItem_;
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> getSettingsItemList() {
      return settingsItem_;
    }
    public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder> 
        getSettingsItemOrBuilderList() {
      return settingsItem_;
    }
    public int getSettingsItemCount() {
      return settingsItem_.size();
    }
    public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem getSettingsItem(int index) {
      return settingsItem_.get(index);
    }
    public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder getSettingsItemOrBuilder(
        int index) {
      return settingsItem_.get(index);
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 511L;
      messageTime_ = 0;
      timeStamp_ = 0L;
      messageBlock_ = 0;
      settingsItem_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(6, messageBlock_);
      }
      for (int i = 0; i < settingsItem_.size(); i++) {
        output.writeMessage(100, settingsItem_.get(i));
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(6, messageBlock_);
      }
      for (int i = 0; i < settingsItem_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(100, settingsItem_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettingsOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getSettingsItemFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 511L;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        messageBlock_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        if (settingsItemBuilder_ == null) {
          settingsItem_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000020);
        } else {
          settingsItemBuilder_.clear();
        }
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings build() {
        ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings buildPartial() {
        ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings result = new ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.messageBlock_ = messageBlock_;
        if (settingsItemBuilder_ == null) {
          if (((bitField0_ & 0x00000020) == 0x00000020)) {
            settingsItem_ = java.util.Collections.unmodifiableList(settingsItem_);
            bitField0_ = (bitField0_ & ~0x00000020);
          }
          result.settingsItem_ = settingsItem_;
        } else {
          result.settingsItem_ = settingsItemBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasMessageBlock()) {
          setMessageBlock(other.getMessageBlock());
        }
        if (settingsItemBuilder_ == null) {
          if (!other.settingsItem_.isEmpty()) {
            if (settingsItem_.isEmpty()) {
              settingsItem_ = other.settingsItem_;
              bitField0_ = (bitField0_ & ~0x00000020);
            } else {
              ensureSettingsItemIsMutable();
              settingsItem_.addAll(other.settingsItem_);
            }
            onChanged();
          }
        } else {
          if (!other.settingsItem_.isEmpty()) {
            if (settingsItemBuilder_.isEmpty()) {
              settingsItemBuilder_.dispose();
              settingsItemBuilder_ = null;
              settingsItem_ = other.settingsItem_;
              bitField0_ = (bitField0_ & ~0x00000020);
              settingsItemBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getSettingsItemFieldBuilder() : null;
            } else {
              settingsItemBuilder_.addAllMessages(other.settingsItem_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              timeStamp_ = input.readInt64();
              break;
            }
            case 48: {
              bitField0_ |= 0x00000010;
              messageBlock_ = input.readInt32();
              break;
            }
            case 802: {
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addSettingsItem(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2 [default = 511];
      private long messageType_ = 511L;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 511L;
        onChanged();
        return this;
      }
      
      // optional int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000008;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int32 messageBlock = 6;
      private int messageBlock_ ;
      public boolean hasMessageBlock() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public int getMessageBlock() {
        return messageBlock_;
      }
      public Builder setMessageBlock(int value) {
        bitField0_ |= 0x00000010;
        messageBlock_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageBlock() {
        bitField0_ = (bitField0_ & ~0x00000010);
        messageBlock_ = 0;
        onChanged();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings.MultiplyDataServerSettingsItem settingsItem = 100;
      private java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> settingsItem_ =
        java.util.Collections.emptyList();
      private void ensureSettingsItemIsMutable() {
        if (!((bitField0_ & 0x00000020) == 0x00000020)) {
          settingsItem_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem>(settingsItem_);
          bitField0_ |= 0x00000020;
         }
      }
      
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder> settingsItemBuilder_;
      
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> getSettingsItemList() {
        if (settingsItemBuilder_ == null) {
          return java.util.Collections.unmodifiableList(settingsItem_);
        } else {
          return settingsItemBuilder_.getMessageList();
        }
      }
      public int getSettingsItemCount() {
        if (settingsItemBuilder_ == null) {
          return settingsItem_.size();
        } else {
          return settingsItemBuilder_.getCount();
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem getSettingsItem(int index) {
        if (settingsItemBuilder_ == null) {
          return settingsItem_.get(index);
        } else {
          return settingsItemBuilder_.getMessage(index);
        }
      }
      public Builder setSettingsItem(
          int index, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem value) {
        if (settingsItemBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSettingsItemIsMutable();
          settingsItem_.set(index, value);
          onChanged();
        } else {
          settingsItemBuilder_.setMessage(index, value);
        }
        return this;
      }
      public Builder setSettingsItem(
          int index, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder builderForValue) {
        if (settingsItemBuilder_ == null) {
          ensureSettingsItemIsMutable();
          settingsItem_.set(index, builderForValue.build());
          onChanged();
        } else {
          settingsItemBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addSettingsItem(ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem value) {
        if (settingsItemBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSettingsItemIsMutable();
          settingsItem_.add(value);
          onChanged();
        } else {
          settingsItemBuilder_.addMessage(value);
        }
        return this;
      }
      public Builder addSettingsItem(
          int index, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem value) {
        if (settingsItemBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSettingsItemIsMutable();
          settingsItem_.add(index, value);
          onChanged();
        } else {
          settingsItemBuilder_.addMessage(index, value);
        }
        return this;
      }
      public Builder addSettingsItem(
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder builderForValue) {
        if (settingsItemBuilder_ == null) {
          ensureSettingsItemIsMutable();
          settingsItem_.add(builderForValue.build());
          onChanged();
        } else {
          settingsItemBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      public Builder addSettingsItem(
          int index, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder builderForValue) {
        if (settingsItemBuilder_ == null) {
          ensureSettingsItemIsMutable();
          settingsItem_.add(index, builderForValue.build());
          onChanged();
        } else {
          settingsItemBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addAllSettingsItem(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem> values) {
        if (settingsItemBuilder_ == null) {
          ensureSettingsItemIsMutable();
          super.addAll(values, settingsItem_);
          onChanged();
        } else {
          settingsItemBuilder_.addAllMessages(values);
        }
        return this;
      }
      public Builder clearSettingsItem() {
        if (settingsItemBuilder_ == null) {
          settingsItem_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000020);
          onChanged();
        } else {
          settingsItemBuilder_.clear();
        }
        return this;
      }
      public Builder removeSettingsItem(int index) {
        if (settingsItemBuilder_ == null) {
          ensureSettingsItemIsMutable();
          settingsItem_.remove(index);
          onChanged();
        } else {
          settingsItemBuilder_.remove(index);
        }
        return this;
      }
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder getSettingsItemBuilder(
          int index) {
        return getSettingsItemFieldBuilder().getBuilder(index);
      }
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder getSettingsItemOrBuilder(
          int index) {
        if (settingsItemBuilder_ == null) {
          return settingsItem_.get(index);  } else {
          return settingsItemBuilder_.getMessageOrBuilder(index);
        }
      }
      public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder> 
           getSettingsItemOrBuilderList() {
        if (settingsItemBuilder_ != null) {
          return settingsItemBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(settingsItem_);
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder addSettingsItemBuilder() {
        return getSettingsItemFieldBuilder().addBuilder(
            ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.getDefaultInstance());
      }
      public ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder addSettingsItemBuilder(
          int index) {
        return getSettingsItemFieldBuilder().addBuilder(
            index, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.getDefaultInstance());
      }
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder> 
           getSettingsItemBuilderList() {
        return getSettingsItemFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder> 
          getSettingsItemFieldBuilder() {
        if (settingsItemBuilder_ == null) {
          settingsItemBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder, ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItemOrBuilder>(
                  settingsItem_,
                  ((bitField0_ & 0x00000020) == 0x00000020),
                  getParentForChildren(),
                  isClean());
          settingsItem_ = null;
        }
        return settingsItemBuilder_;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings)
    }
    
    static {
      defaultInstance = new MultiplyDataServerSettings(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataServerSettings)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\022MultiplyData.proto\022.ru.omnicomm.pegasu" +
      "s.messaging.settings.general\"\307\003\n\032Multipl" +
      "yDataServerSettings\022\020\n\010sourceId\030\001 \001(\003\022\030\n" +
      "\013messageType\030\002 \002(\003:\003511\022\023\n\013messageTime\030\003" +
      " \001(\005\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014messageBlock\030" +
      "\006 \001(\005\022\177\n\014settingsItem\030d \003(\0132i.ru.omnicom" +
      "m.pegasus.messaging.settings.general.Mul" +
      "tiplyDataServerSettings.MultiplyDataServ" +
      "erSettingsItem\032\275\001\n\036MultiplyDataServerSet" +
      "tingsItem\022\020\n\010sourceId\030\001 \001(\003\022\025\n\nmultiplie",
      "r\030\002 \001(\001:\0011\022\030\n\020inputMessageType\030\003 \001(\005\022\035\n\025" +
      "inputMessageValueType\030\004 \001(\005\022\031\n\021outputMes" +
      "sageType\030\005 \001(\005\022\036\n\026outputMessageValueType" +
      "\030\006 \001(\005BL\n.ru.omnicomm.pegasus.messaging." +
      "settings.generalB\032MultiplyDataSettingsPa" +
      "rser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "TimeStamp", "MessageBlock", "SettingsItem", },
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.class,
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_general_MultiplyDataServerSettings_MultiplyDataServerSettingsItem_descriptor,
              new java.lang.String[] { "SourceId", "Multiplier", "InputMessageType", "InputMessageValueType", "OutputMessageType", "OutputMessageValueType", },
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.class,
              ru.omnicomm.pegasus.messaging.settings.general.MultiplyDataSettingsParser.MultiplyDataServerSettings.MultiplyDataServerSettingsItem.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  // @@protoc_insertion_point(outer_class_scope)
}
